import java.awt.Graphics2D;
import java.awt.geom.*;
import java.awt.*;
/**
 * Clase Grafica de la clase Bloque. Esta clase fue modificada.
 * @author Luis Fuentes / Benjamin Ginouves
 */
public class GBlock extends Block implements Draggable {
   private float width, height;
   private Color color = Color.GRAY;
   Ellipse2D.Float ellipse = null;
   /**
    * Inicializador del objeto Bloque.
    * @param mass masa del bloque.
    * @param position vector posicion del bloque.
    * @param speed vector velocidad del bloque.
    * @param width ancho del bloque.
    * @param height altura del bloque.
    * @param fixed identificador si el bloque esta fijo o no.
    */
   public GBlock (float mass, Vector2D position, Vector2D speed,
                  float width, float height,boolean fixed){
      super(mass, position,speed,fixed);
      this.width = width;
      this.height = height;
      ellipse = new Ellipse2D.Float((float)pos_t.getX()-width/2, (float)pos_t.getY()-height/2, width, height);
   }
   /**
    * Metodo para especificar el elemento grafico del bloque, y posicionarlo en el frame.
    * @param g elemento grafico del bloque.
    */
   public void draw (Graphics2D g){
      ellipse.setFrame((float)pos_t.getX()-width/2, (float)pos_t.getY()-height/2, width, height);
      g.setColor(color);
      g.fill(ellipse);
   }
   /**
    * Metodo para identificar si el punto esta contenido dentro de la elipse que identifica al bloque.
    * @param x coordenada x del punto a evaluar.
    * @param y coordenada y del punto a evaluar.
    * @return valor si esta o no contenido el punto evaluado.
    */
   public boolean contains (double x, double y){
      return ellipse.contains(x,y);
   }
   /**
    * Metodo para evaluar si el extremo del vector esta contenido dentro del bloque.
    * @param v vector a evaluar.
    * @return valor si esta o no contenido el extremo evaluado.
    */
   public boolean contains (Vector2D v) {
      return ellipse.contains(v.getX(), v.getY());
   }
   /**
    * Metodo para mover el objeto grafico del bloque.
    * @param x coordenada x a la cual se quiere mover el objeto grafico del bloque.
    * @param y coordenada y a la cual se quiere mover el objeto grafico del bloque.
    */
   public void drag(double x, double y){
      pos_t = new Vector2D(x,y);
      speed_t = new Vector2D();
      pos_tPlusDelta = pos_t;
      speed_tPlusDelta = speed_t;
   }
   /**
    * Establece el color del bloque a rojo.
    */
   public void setSelectedColor (){
      color = Color.RED;
   }
   /**
    * Establece el color del bloque a GRIS.
    */
   public void setDefaultColor() {
      color = Color.GRAY;
   }
   /**
    * Metodo no utilizado.
    * @param x
    * @param y
    * @param bsc
    */
   public void attachNearElement(double x, double y, BlockSpringConfiguration bsc){
   }
}
