import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.*;
import java.awt.event.*;
/**
 * Clase de la barra de menu del panel.
 * @author Luis Fuentes
 */
public class LabMenuBar extends JMenuBar {
    /**
     * Implementacion de la barra de menu de opciones
     * @param iel eventos de insersion de objetos fisicos.
     * @param sl eventos de las opciones del simulador.
     */
    public LabMenuBar(InsertElementListener iel, SimulatorListener sl) {
      JMenu menu = new JMenu ("Insert");
      add(menu);
      JMenuItem menuItem = new JMenuItem("Mass");
      menuItem.addActionListener(iel);
      menu.add(menuItem);
      menuItem = new JMenuItem("Spring");
      menuItem.addActionListener(iel);
      menu.add(menuItem);
      menuItem = new JMenuItem("String");
      menuItem.addActionListener(iel);
      menu.add(menuItem);
      menu = new JMenu("Simulator");
      add(menu);
      menuItem = new JMenuItem("Start");
      menuItem.addActionListener(sl);
      menu.add(menuItem);
      menuItem = new JMenuItem("Stop");
      menuItem.addActionListener(sl);
      menu.add(menuItem);
      JMenu subMenu = new JMenu("Setting");
      menu.add(subMenu);
      menuItem = new JMenuItem("Delta t");
      menuItem.addActionListener(sl);
      subMenu.add(menuItem);
      menuItem = new JMenuItem("Refresh time");
      menuItem.addActionListener(sl);
      subMenu.add(menuItem);
      menuItem = new JMenuItem("Gravity");
      menuItem.addActionListener(sl);
      subMenu.add(menuItem);
      menuItem = new JCheckBoxMenuItem("Damping");
      ((JCheckBoxMenuItem)menuItem).setState(true);
      menuItem.addActionListener(sl);
      subMenu.add(menuItem);
   }
}