import java.awt.event.*;
import javax.swing.JOptionPane;
import javax.swing.JMenuItem;
/**
 * Clase que implementa la seccion de simulacion de la barra de menu, para modificar los valores de la simulacion.
 */
public class SimulatorListener implements ActionListener {
   private Simulator simulator; //Simulador a modificar.
    /**
    * Constructor para SimulatorListener
    * @param s Simulador a modificar.
    */
   public SimulatorListener (Simulator s){
      simulator = s;
   }
   /**
    * Accion a seguir al producirse un evento en el menu, identificando que accion se desea realizar.
    * @param e Evento capturado desde el menu de simlacion
    * @throws NumberFormatException
    */
   public void actionPerformed(ActionEvent e) throws NumberFormatException{
      JMenuItem menuItem = (JMenuItem)(e.getSource());
      NumberFormatException b = new NumberFormatException("Negative number");
      String text = menuItem.getText();
      boolean flag = true;
      if (text.equals("Start")) simulator.start();
      if (text.equals("Stop")) simulator.stop();
      while (flag){
          try{
             if (text.equals("Delta t")) {
                 String delta = JOptionPane.showInputDialog("Enter delta t:");
                 if (Float.parseFloat(delta) < 0) throw(b);
                 simulator.setDelta_t(Float.parseFloat(delta));
                 flag = false;
             }

             if (text.equals("Refresh time")) {
                String delta = JOptionPane.showInputDialog("Enter refresh time:");
                if (Float.parseFloat(delta) < 0) throw(b);
                simulator.setSamplingPeriod(Float.parseFloat(delta));
                flag = false;
             }

             if (text.equals("Gravity")) {
                String delta = JOptionPane.showInputDialog("Enter Gravity:");
                if (Float.parseFloat(delta)> 0)
                if (Float.parseFloat(delta) < 0) throw(b);
                simulator.setGravity(Float.parseFloat(delta)*100);
                flag = false;
             }
             
             if (text.equals("Damping")) {
                   simulator.setDamping();
                   flag = false;
             }


             else flag = false;

          } catch (NumberFormatException a){
                     JOptionPane.showMessageDialog(menuItem, "Invalid input, please enter real positive numbers", "Error", JOptionPane.ERROR_MESSAGE);
          } catch (NullPointerException a){
                     flag = false;
          }
      }
   }
}
